#include <stdlib.h>
#include <iostream>

class Toggle {
public:
    Toggle(bool start_state) : state(start_state) { }
    virtual bool value() {
		return(state);
    }
    Toggle& activate() {
		state = !state;
		return(*this);
    }
    bool state;
};

class NthToggle : public Toggle {
public:
    NthToggle(bool start_state, int max_counter) :
		Toggle(start_state), count_max(max_counter), counter(0) {
    }
    NthToggle& activate() {
		if (++this->counter >= this->count_max) {
		    state = !state;
		    counter = 0;
		}
		return(*this);
    }
private:
    int count_max;
    int counter;
};

int
main(int argc, char *argv[]) {
    int n = ((argc == 2) ? atoi(argv[1]) : 1);

    bool val = true;
    Toggle toggle(val);
    for (int i=0; i<n; i++) {
		val = toggle.activate().value();
    }
    cout << ((val) ? "true" : "false") << endl;

    val = true;
    NthToggle ntoggle(val, 3);
    for (int i=0; i<n; i++) {
		val = ntoggle.activate().value();
    }
    cout << ((val) ? "true" : "false") << endl;

    return 0;
}

